//
//  Parser.h
//  XMLParserTest
//
//  Created by Angus Hardie on 07/06/2005.
//  Copyright 2005 MalcolmHardie Solutions Ltd. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "MHStack.h"


@interface Parser : NSObject <NSXMLParserDelegate> 

{
	NSMutableString* currentStringValue;
	NSString* curElementName;
	
	MHStack* objectStack;
    id topObject;
	id container;
	
	BOOL _recoveryMode;
}

@property (assign) BOOL forceSafePropertySetter;

- (BOOL)parseXMLFile:(NSString *)pathToFile withContainer:(id)container;
- (id)parseXMLFromString:(NSString*)data;
- (BOOL)parseXMLFromString:(NSString*)data withContainer:(id)newContainer ;
- (id)parseXMLFromPath:(NSString*)path;
- (BOOL)parseXMLFromData:(NSData*)data withContainer:(id)newContainer;
- (BOOL)parseXMLWithRecoveryFromData:(NSData*)data withContainer:(id)newContainer;
@end
